<?php
// ----------------------------------------------------------------------
// eNvolution Content Management System
// Copyright (C) 2002 by the eNvolution Development Team.
// http://www.envolution.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - www.postnuke.com
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// ----------------------------------------------------------------------------
// Original Author of file: Scott Kirkwood (scott_kirkwood@bigfoot.com)
// Purpose of file: Routines to modify the env-config.php file.
// General routine modify_file() is useful in it's own right.
// ----------------------------------------------------------------------------
// This is the last update to this script before the new version is finished.

// mod_file is general, give it a source file a destination.
// an array of search patterns (Perl style) and replacement patterns
// Returns a string which starts with "Err" if there's an error
// ----------------------------------------------------------
/* ChangeLog
 * 1/08/2003          WindMeUp                        change the home of config.php to /config
 *                                                                        and rename to env-config.php
*/

function copy_config_file()
{
$errors = '';

        if(file_exists('config.php') != FALSE) {
                clearstatcache();
               if (is_writeable('config.php') != 1) {
                $errors .=  ""._ERRORINST1."";
                } else {
                        clearstatcache();
                        if (!@copy('config/config.php','config.php')){
                        $errors .=  ""._ERRORINST2."";
                        }
                }
        } else {
                clearstatcache();
                if (!@copy('config/config.php','config.php')){
                       $errors .=  ""._ERRORINST3."";
                }
        }
        return $errors;
}


function modify_file($src, $dest, $reg_src, $reg_rep)
{
    $in = @fopen($src, "r");
    if (! $in)
    {
        return _MODIFY_FILE_1." $src";
    }
    $i = 0;
    while (!feof($in))
    {
        $file_buff1[$i++] = fgets($in, 4096);
    }
    fclose($in);

    $lines = 0; // Keep track of the number of lines changed

    while (list ($bline_num, $buffer) = each ($file_buff1))
    {
        $new = preg_replace($reg_src, $reg_rep, $buffer);
        if ($new != $buffer) {
            $lines++;
        }
        $file_buff2[$bline_num] = $new;
    }

    if ($lines == 0)
    {
        // Skip the rest - no lines changed
        return _MODIFY_FILE_3;
    }

    reset($file_buff1);
    $out_backup = @fopen($dest, "w");

    if (! $out_backup)
    {
        return _MODIFY_FILE_2." $dest";
    }

    while (list ($bline_num, $buffer) = each ($file_buff1))
    {
        fputs($out_backup,$buffer);
    }

    fclose($out_backup);

    reset($file_buff2);
    $out_original = fopen($src, "w");
    if (! $out_original)
    {
        return _MODIFY_FILE_2." $src";
    }

    while (list ($bline_num, $buffer) = each ($file_buff2))
    {
        fputs($out_original,$buffer);
    }

    fclose($out_original);

    // Success!
    return "$src "._UPDATEDINST."  $lines "._LINESINST." $dest";
}

// Two global arrays
$reg_src = array();
$reg_rep = array();

// Setup various searches and replaces
// Scott Kirkwood
function add_src_rep($key, $rep)
{
    global $reg_src, $reg_rep;

    // Note: /x is to permit spaces in regular expressions
    // Great for making the reg expressions easier to read

    // Ex: $pnconfig['sitename'] = stripslashes("Your Envolution Site Name");
    $reg_src[] = "/ \['$key'\] \s* = \s* stripslashes\( (\' | \") (.*) \\1 \); /x";
    $reg_rep[] = "['$key'] = stripslashes(\\1$rep\\1);";

    // Ex. $pnconfig['site_logo'] = "logo.gif";
    $reg_src[] = "/ \['$key'\] \s* = \s* (\' | \") (.*) \\1 ; /x";
    $reg_rep[] = "['$key'] = '$rep';";

    // Ex. $pnconfig['pollcomm'] = 1;
    $reg_src[] = "/ \['$key'\] \s* = \s* (\d*\.?\d*) ; /x";
    $reg_rep[] = "['$key'] = $rep;";
}

function show_error_info()
{
    global $dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype;

    echo "<br/><br/><b>"._SHOW_ERROR_INFO_1."<br/>";
echo <<< EOT
        <tt>
        \$pnconfig['dbtype'] = '$dbtype';<br/>
        \$pnconfig['dbhost']  = '$dbhost';<br/>
        \$pnconfig['dbuname'] = '$dbuname';<br/>
        \$pnconfig['dbpass'] = '$dbpass';<br/>
        \$pnconfig['dbname'] = '$dbname';<br/>
        \$pnconfig['prefix'] = '$prefix';<br/>
        </tt>
EOT;

}

// Update the env-config.php file with the database information.
function update_config_php($db_prefs = false)
{
    global $reg_src, $reg_rep;
    global $dbhost, $dbuname, $dbpass, $dbname, $prefix, $dbtype;
    global $email, $url,  $HTTP_ENV_VARS;

    add_src_rep("dbhost", $dbhost);
    add_src_rep("dbuname", base64_encode($dbuname));
    add_src_rep("dbpass", base64_encode($dbpass));
    add_src_rep("dbname", $dbname);
    add_src_rep("prefix", $prefix);
    add_src_rep("dbtype", $dbtype);
    if (strstr($HTTP_ENV_VARS["OS"],"Win")) {
        add_src_rep("system" , '1');
    } else {
        add_src_rep("system", '0');
    }
    add_src_rep("encoded", '1');

    if ($email)
    {
        add_src_rep("adminmail", $email);
    }

        $ret = copy_config_file();
    $ret .= modify_file("config/env-config.php", "config/config-old.php", $reg_src, $reg_rep);

    if (preg_match("/Error/", $ret))
    {
                echo "<br><hr><font class=\"pn-sub\">config.php: ".$ret."</font><hr>";
        show_error_info();
    } else {
                echo "<br><hr><font class=\"pn-sub\">config.php: ".$ret."</font><hr>";
        }
}

// Create or overwrite the file rte-config.php
function update_rte_config($switch = false)
{
global $root_path, $pnrootpath, $upload_path;

if($switch)
{
// Create or modify js_config.php for the image-picker
    $d = date('Y-F-d-H:i:s');
    $content = "<?php // Generated: $d\n"
        ."// ----------------------------------------------------------------------\n"
                ."/**\n"
                ."This is the config-file for some defaults to setting up the imagePicker\n"
                ."The imagePicker is an enhancement for the Richtext-Editor\n"
                ."\n"
                ."Name: rte-config.php\n"
                ."Description: DON'T EDIT THIS FILE MANUALLY. IT WILL BE GENERATED AUTOMATICALLY\n"
                ."Author: Stefan Khler (s.koehler@prowings.de)\n"
                ."**/\n"
        ."// ----------------------------------------------------------------------\n"
                ."global \$IMG_ACCEPT;\n"
                ."\n"
                ."define('PN_ROOT_PATH','$pnrootpath'); //Root-path of Postnuke (neccessary for including relative URLs in contents)\n"
                ."define('IMG_UPLOAD_SRC',''); //upload page (not used yet)\n"
                ."define('IMG_UPLOAD_LINK',''); //page to go after upload (not used yet)\n"
                ."define('IMG_UPLOAD_DIR','$root_path$upload_path'); //default image upload location, if upload page is not specified\n"
                ."define('IMG_PATH','$upload_path'); //relative path from document to images, to be view from document\n"
                ."define('MAX_FILESIZE','10240'); //max. filesize in bytes for uploading images \n"
                ."\$IMG_ACCEPT = array('image/gif','image/pjpeg','image/jpg','image/jpeg'); //acceptable types\n"
        ."// ----------------------------------------------------------------------\n"
        .'?'.'>'
    ;
    // I can't seem to get around the stupid PHP file owner problem :-(
    //$tmpf = tempnam('tmp', 'postnuke_');
    //$fp = fopen("$tmpf.php", w);
    $fp = @fopen('config/rte-config.php', w);
    if (!$fp) die (sprintf(_CHMOD_CHECK_3A_FAIL,'rte-config.php','rte-config.php'));
    fwrite($fp, $content);
    fclose($fp);
}
    return true;
}

// Create or overwrite the file sub-config.php
function update_sub_config($switch = false)
{
global $pages_upload_path, $root_path;

if($switch)
{
// Create or modify js_config.php for the image-picker
    $d = date('Y-F-d-H:i:s');
    $content = "<?php // Generated: $d\n"
        ."// ----------------------------------------------------------------------\n"
                ."/**\n"
                ."This is the config-file for some defaults to setting up the Filemanager\n"
                ."The Filemanager is part of the Subjects-Module\n"
                ."\n"
                ."Name: sub-config.php\n"
                ."Description: DON'T EDIT THIS FILE MANUALLY. IT WILL BE GENERATED AUTOMATICALLY\n"
                ."Author: Stefan Khler (s.koehler@prowings.de)\n"
                ."**/\n"
        ."// ----------------------------------------------------------------------\n"
		."if(!isset($ModName))\n"
    	."\$ModName = basename( dirname( __FILE__ ) );\n"
		."//do you want to use WYSIWYG editor?\n"
		."\$subjectsconfig['wysiwygeditor'] = 0;\n"
		."//settings for file manager\n"
		."\$subjectsconfig['maxfilesize'] = '1000000'; // max file size in bytes\n"
		."\$subjectsconfig['hddspace'] = '100000000'; // max total size of all files in directory\n"
		."\$subjectsconfig['hiddenfiles'] = array('.htaccess'); // add any file names to this array which should remain invisible\n"
		."\$subjectsconfig['hiddendirs'] = array(''); // add any file names to this array which should remain invisible\n"
		."\$subjectsconfig['editextensions'] = array('htm','html','txt','php'); // add the extensions of file types that you would like to be able to edit\n"
		."\$subjectsconfig['imageextensions'] = array('jpg','jpeg','png','bmp','gif'); // add the extensions of image file type\n"
		."\$subjectsconfig['pagespath'] = '$root_path$pages_upload_path'; //full path for modules/$ModName/pages folder with slash at the end\n"
        .'?'.'>'
    ;
    // I can't seem to get around the stupid PHP file owner problem :-(
    //$tmpf = tempnam('tmp', 'postnuke_');
    //$fp = fopen("$tmpf.php", w);
    $fp = @fopen('config/sub-config.php', w);
    if (!$fp) die (sprintf(_CHMOD_CHECK_3A_FAIL,'sub-config.php','sub-config.php'));
    fwrite($fp, $content);
    fclose($fp);
}
    return true;
}
?>