<?php

// ----------------------------------------------------------------------
// eNvolution Content Management System
// Copyright (C) 2002 by the eNvolution Development Team.
// http://www.envolution.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - www.postnuke.com
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//


/*

 * Smarty plugin

 * ------------------------------------------------------------

 * Type:     modifier

 * Name:     escape

 * Purpose:  Escape the string according to escapement type

 * ------------------------------------------------------------

 */

function smarty_modifier_escape($string, $esc_type = 'html')

{

    switch ($esc_type) {

        case 'html':

            return htmlspecialchars($string, ENT_QUOTES);



        case 'htmlall':

            return htmlentities($string, ENT_QUOTES);



        case 'url':

            return urlencode($string);



        case 'quotes':

            // escape unescaped single quotes

            return preg_replace("%(?<!\\\\)'%", "\\'", $string);



		case 'hex':

			// escape every character into hex

			for ($x=0; $x < strlen($string); $x++) {

				$return .= '%' . bin2hex($string[$x]);

			}

			return $return;

            

		case 'hexentity':

			for ($x=0; $x < strlen($string); $x++) {

				$return .= '&#x' . bin2hex($string[$x]) . ';';

			}

			return $return;



        default:

            return $string;

    }

}



/* vim: set expandtab: */



?>

