<?php
// ----------------------------------------------------------------------
// eNvolution Content Management System
// Copyright (C) 2002 by the eNvolution Development Team.
// http://www.envolution.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - www.postnuke.com
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// File: $Id: funcs.php,v 1.3 2003/02/11 03:22:42 timax Exp $ $Name:  $
// Copyright (c) 2002 by Brian K. Virgin (madhatter7@envolution.com)
// http://www.envolution.com
// Envolution Content Management System - http://www.envolution.com
// 
// ----------------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please read the docs/license.txt or visit
// http://www.gnu.org/copyleft/gpl.html
//
// ----------------------------------------------------------------------------
// Filename: User Points		funcs.php
// Original Author of file: Brian K. Virgin (aka 'MADHATter7')
// Purpose of file: User Points System Utility Functions
// ----------------------------------------------------------------------------
// Changelog
//  7-04-2002:	Zoom - converted blackadders .713 port and updated plugins
//  11-01-2002: mh7 - initial release
// ----------------------------------------------------------------------------


global $score, $calc, $toshow, $forums, $refreshtime;

//////																	  //////
//						Begin Configuration Section							  //
//////																	  //////


//////
// Number of users to display
//////
$toshow = 20;

//////
//							Refresh period:
//	--------------------------------------------------------------
//  3600 = 1 hour		 43200 = 12 hours		  86400 = 24 hours
//604800 = 1 week		907200 = 1/2 month		2592000 = 1 month
//	[ 7 days ]				[ 15 days ]				[ 30 days ]
//////
$refreshtime = 60;		// every minute


//////
// Place your Forums Module name here
// and then place function in the plugins/ directory.
// (XForums, phpBB & Postboard and several others included)
//////
$forums = "phpBB2";


//////
// Setup activity scoring system (what each action is worth)
//////
$score = array(
	"stories" => 4,				// for every Story
	"reviews" => 6,				// for every Review
	"comments" => 2, 			// for Story Comments
	"pollcomm" => 2, 			// for Poll Comments
	"reviewcomm" => 2,			// for Review Comments
	"downloads" => 3,			// for Submited Downloads
	"dloadvotes" => 2,			// for votes on Downloads
	"links" => 3,				// for Web Links
	"linkvotes" => 2,			// for votes on Links
	"posts" => 1				// for Forum Posts
);

//////
// Setup which activities we will be scoring
// Calculate score = 1, ignore = 0
//////
$calc = array(
	"stories" => 1,
	"reviews" => 1,
	"comments" => 1,
	"pollcomm" => 1,
	"reviewcomm" => 1,
	"downloads" => 1,
	"dloadvotes" => 1,
	"links" => 1,
	"linkvotes" => 1,
	"posts" => 1
);

//////																	  //////
//						End Configuration Section							  //
//////																	  //////


//////
// Tabulate the stories
//////
function tabStories($uname) {
	global $dbconn, $pntable, $prefix;
	$query = "SELECT count(*) FROM $pntable[stories] WHERE pn_time > date_add(now(),interval-31 day) and pn_informant='$uname'";
	$result = $dbconn->Execute($query);
	if ($dbconn->ErrorNo() <> 0) {
		echo "DB Error: ".$dbconn->ErrorNo().": ".$dbconn->ErrorMsg()."<br />";
		exit();
	}
	if ($result->EOF) {
		return;
	}
	$abacus = $result->fields[0];
	$result->Close();
	return $abacus;
}

//////
// Tabulate article comments
//////
function tabComments($uname) {
	global $dbconn, $pntable, $prefix;
	$query = "SELECT count(*) FROM $pntable[comments] WHERE pn_date > date_add(now(),interval-31 day) and pn_name='$uname'";
	$result = $dbconn->Execute($query);
	if ($dbconn->ErrorNo() <> 0) {
		echo "DB Error: ".$dbconn->ErrorNo().": ".$dbconn->ErrorMsg()."<br />";
		exit();
	}
	if ($result->EOF) {
		return;
	}
	$abacus = $result->fields[0];
	$result->Close();
	return $abacus;
}

//////
// Tabulate poll comments
//////
function tabPollComm($uname) {
	global $dbconn, $pntable, $prefix;
	$query = "SELECT count(*) FROM  $pntable[pollcomments] WHERE pn_date > date_add(now(),interval-31 day) and pn_name='$uname'";
	$result = $dbconn->Execute($query);
	if ($dbconn->ErrorNo() <> 0) {
		echo "DB Error: ".$dbconn->ErrorNo().": ".$dbconn->ErrorMsg()."<br />";
		exit();
	}
	if ($result->EOF) {
		return;
	}
	$abacus = $result->fields[0];
	$result->Close();
	return $abacus;
}

//////
// Tabulate posted downloads
//////
function tabDownloads($uname) {
	global $dbconn, $pntable, $prefix;
	$query = "SELECT count(*) FROM $pntable[downloads_downloads] WHERE pn_date > date_add(now(),interval-31 day) and pn_submitter='$uname'";
	$result = $dbconn->Execute($query);
	if ($dbconn->ErrorNo() <> 0) {
		echo "DB Error: ".$dbconn->ErrorNo().": ".$dbconn->ErrorMsg()."<br />";
		exit();
	}
	if ($result->EOF) {
		return;
	}
	$abacus = $result->fields[0];
	$result->Close();
	return $abacus;
}

//////
// Tabulate download votes
//////
function tabDloadVotes($uname) {
	global $dbconn, $pntable, $prefix;
	$pntable[downloads_votedata] = $prefix."_downloads_votedata";
	$query = "SELECT count(*) FROM $pntable[downloads_votedata] WHERE pn_timestamp > date_add(now(),interval-31 day) and pn_user='$uname'";
	$result = $dbconn->Execute($query);
	if ($dbconn->ErrorNo() <> 0) {
		echo "DB Error: ".$dbconn->ErrorNo().": ".$dbconn->ErrorMsg()."<br />";
		exit();
	}
	if ($result2->EOF) {
		return;
	}
	$abacus = $result->fields[0];
	$result->Close();
	return $abacus;
}

//////
// Tabulate posted web links
//////
function tabWebLinks($uname) {
	global $dbconn, $pntable, $prefix;
	$query = "SELECT count(*) FROM $pntable[links_links] WHERE pn_date > date_add(now(),interval-31 day) and pn_submitter='$uname'";
	$result = $dbconn->Execute($query);
	if ($dbconn->ErrorNo() <> 0) {
		echo "DB Error: ".$dbconn->ErrorNo().": ".$dbconn->ErrorMsg()."<br />";
		exit();
	}
	if ($result->EOF) {
		return;
	}
	$abacus = $result->fields[0];
	$result->Close();
	return $abacus;
}

//////
// Tabulate link votes
//////
function tabLinkVotes($uname) {
	global $dbconn, $pntable, $prefix;
	$query = "SELECT count(*) FROM $pntable[links_votedata] WHERE pn_timestamp > date_add(now(),interval-31 day) and pn_user='$uname'";
	$result = $dbconn->Execute($query);
	if ($dbconn->ErrorNo <> 0) {
		echo"DB Error: ".$dbconn->ErrorNo().": ".$dbconn->ErrorMsg()."<br />";
	}
	if ($result->EOF) {
		return;
	}
	$abacus = $result->fields[0];
	$result->Close();
	return $abacus;
}

//////
// Tabulate posted reviews
//////
function tabReviews($uname) {
	global $dbconn, $pntable, $prefix;
	$query = "SELECT count(*) FROM $pntable[reviews] WHERE pn_date > date_add(now(),interval-31 day) and pn_reviewer='$uname'";
	$result = $dbconn->Execute($query);
	if ($dbconn->ErrorNo() <> 0) {
		echo "DB Error: ".$dbconn->ErrorNo().": ".$dbconn->ErrorMsg()."<br />";
		exit();
	}
	if ($result->EOF) {
		return;
	}
	$abacus = $result->fields[0];
	$result->Close();
	return $abacus;
}

//////
// Tabulate review comments
//////
function tabReviewComm($uname) {
	global $dbconn, $pntable, $prefix;
	//$pntable[reviews_comments] = $prefix."_reviews_comments";

	$query = "SELECT count(*) FROM $pntable[reviews_comments] WHERE pn_date > date_add(now(),interval-31 day) and pn_userid='$uname'";
	$result = $dbconn->Execute($query);
	if ($dbconn->ErrorNo() <> 0) {
		echo "DB Error: ".$dbconn->ErrorNo().": ".$dbconn->ErrorMsg()."<br />";
		exit();
	}
	if ($result->EOF) {
		return;
	}
	$abacus = $result->fields[0];
	$result->Close();
	return $abacus;
}

//////
// Tabulate forum posts (via plugin)
//////
function tabPosts($uname) {
	global $dbconn, $pntable, $prefix, $ModName, $forums;

	if (isset($forums) && $forums != "none") {
		if (file_exists("modules/$ModName/plugins/$forums.php")) {
			require("modules/$ModName/plugins/$forums.php");
		}
	}
	return $abacus;
}

?>
