<?php
// ----------------------------------------------------------------------
// eNvolution Content Management System
// Copyright (C) 2002 by the eNvolution Development Team.
// http://www.envolution.com/
// ----------------------------------------------------------------------
// Based on:
// Postnuke Content Management System - www.postnuke.com
// PHP-NUKE Web Portal System - http://phpnuke.org/
// Thatware - http://thatware.org/
// ----------------------------------------------------------------------
// LICENSE
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License (GPL)
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// To read the license please visit http://www.gnu.org/copyleft/gpl.html
//
// ----------------------------------------------------------------------------
// Original Author of file: Jim McDonald
// Purpose of file: Utility functions for news
// ----------------------------------------------------------------------
        define('_CONFIG_MODULE', 'News');

function getArticles($where, $order, $limit, $startnum=0, $countonly=0) {

    //global $numstories;

    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $currentlang = pnUserGetLang();

        $numstories=0;
    // Columns
    $storiescolumn = $pntable['stories_column'];
    $storiescatcolumn= $pntable['stories_cat_column'];
    $topicscolumn = $pntable['topics_column'];

    // Base query
         if ($countonly)
    {
        $query = "SELECT count(*) FROM $pntable[stories]";
    } else {
                $query = "SELECT $storiescolumn[aid] AS \"aid\",
                    $storiescolumn[bodytext] AS \"bodytext\",
                    $storiescatcolumn[themeoverride] AS \"catthemeoverride\",
                    $storiescolumn[catid] AS \"cid\",
                    $storiescatcolumn[title] AS \"cattitle\",
                    $storiescolumn[comments] AS \"comments\",
                    $storiescolumn[counter] AS \"counter\",
                    $storiescolumn[hometext] AS \"hometext\",
                    $storiescolumn[informant] AS \"informant\",
                    $storiescolumn[notes] AS \"notes\",
                    $storiescolumn[sid] AS \"sid\",
                    $storiescolumn[themeoverride] AS \"themeoverride\",
                    $topicscolumn[topicid] AS \"tid\",
                    $storiescolumn[time] AS \"time\",
                    $storiescolumn[title] AS \"title\",
                    $topicscolumn[topicname] AS \"topicname\",
                    $topicscolumn[topicimage] AS \"topicimage\",
                    $topicscolumn[topictext] AS \"topictext\",
                    $topicscolumn[counter] AS \"tcounter\",
                    $storiescolumn[time] AS \"unixtime\",
                    $storiescolumn[withcomm] AS \"withcomm\",
                    $storiescolumn[skins] AS \"skins\"
             FROM $pntable[stories]";
        }

    if (strcmp(pnConfigGetVar('dbtype'), 'oci8') == 0) {
        $query .=  " , $pntable[stories_cat], $pntable[topics]
                    WHERE $storiescolumn[catid]=$storiescatcolumn[catid](+)
                     AND $topicscolumn[topicid]=$storiescolumn[topic]";
        if (pnConfigGetVar('multilingual') == 1) {
            $query .= " AND ($storiescolumn[alanguage]='$currentlang' OR $storiescolumn[alanguage]='')";
        }

        if (!empty($limit)) {
            $query .= " AND ROWNUM < $limit";
        }

        if (!empty($where)) {
            $query .= " AND $where";
        }

        if (!empty($order)) {
            $query .= " ORDER BY $order";
        }

    } else {   // Assume mysql
        $query .= " LEFT JOIN $pntable[stories_cat] ON $storiescolumn[catid] = $storiescatcolumn[catid]
                    LEFT JOIN $pntable[topics] ON $storiescolumn[topic] = $topicscolumn[topicid]";

        if (pnConfigGetVar('multilingual') == 1) {
            $query .= " WHERE ($storiescolumn[alanguage]='" . pnUserGetLang() . "' OR $storiescolumn[alanguage]='')";
            if (!empty($where)) {
                $query .= " AND $where";
            }
        } else {
            if (!empty($where)) {
                $query .= " WHERE $where";
            }
        }

        if (!empty($order)) {
            $query .= " ORDER BY $order";
        }

        if (!empty($order)) {
            $result = $dbconn->SelectLimit($query, $limit, $startnum);
        }
        else {
            $result = $dbconn->Execute($query);
        }
        if($dbconn->ErrorNo() != 0) {
            echo "DB Error: getArticles: " . $dbconn->ErrorNo() . ': ' . $dbconn->ErrorMsg() . '<br>';
            exit ();
        }
                if ($countonly)
        {
            list($res) = $result->fields;
        } else {
            $i = 0;
            $res = array();
            $numstories = $result->PO_RecordCount();
            while(!$result->EOF) {
                $row = $result->GetRowAssoc(false);
                $row['unixtime']=$result->UnixTimeStamp($row['unixtime']);
                $row['topicid'] = $row['tid'];
                $row['topic'] = $row['tid'];
                $row['catid'] = $row['cid'];
            if ($row['cattitle'] == "") { $row['cattitle'] = "". _ARTICLES . ""; }
                $res[$i] = $row;
                $i++;
                $result->MoveNext();
            }
        }

        $result->Close();
        return($res);
    }
}

function genArticleInfo($row) {


    setlocale(LC_TIME, pnConfigGetVar('locale'));

    $info = $row;
    $info['version'] = 1;
    $info['longdatetime'] = ml_ftime(_DATETIMELONG, GetUserTime($info['unixtime']));
    $info['briefdatetime'] = ml_ftime(_DATETIMEBRIEF, GetUserTime($info['unixtime']));
    $info['longdate'] = ml_ftime(_DATELONG, GetUserTime($info['unixtime']));
    $info['briefdate'] = ml_ftime(_DATEBRIEF, GetUserTime($info['unixtime']));
    $anonymous = pnConfigGetVar('anonymous');
    if (empty($info['informant'])) {
        $info['informant'] = $anonymous;
    }

    list($info['title'],
         $info['hometext'],
         $info['bodytext'],
         $info['notes']) = pnModCallHooks('item',
                                          'transform',
                                          '',
                                          array($info['title'],
                                                $info['hometext'],
                                                $info['bodytext'],
                                                $info['notes']));

    $info['title'] = preg_replace('/<a\s+.*?>(.*?)<\/a>/i', '\\1', $info['title']);
    $info['title'] = pnVarPrepForDisplay(pnVarCensor($info['title']));
    $info['hometext'] = pnVarPrepHTMLDisplay(pnVarCensor($info['hometext']));
    $info['bodytext'] = pnVarPrepHTMLDisplay(pnVarCensor($info['bodytext']));
    $info['notes'] = pnVarPrepHTMLDisplay(pnVarCensor($info['notes']));
    $info['cattitle'] = pnVarPrepHTMLDisplay(pnVarCensor($info['cattitle']));
    if ($info['catid']) {
        $info['catandtitle'] = $info['cattitle'].": ".$info['title'];
    } else {
        $info['catandtitle'] = $info['title'];
    }

    $bodytxt = explode( "[pagebreak]", $info['bodytext'] );
    $lastpage = count($bodytxt);
    if ( $pagenum < 1 )
        $pagenum = 1;
    if ( $pagenum > $lastpage )
        $pagenum = $lastpage;
    if ($lastpage > 1) {
        $info['bodytext'] = $bodytxt[$pagenum - 1]."<br /><center><b>"._PAGE.":</b> $pagenum/$lastpage</center><br />";
    }
    if($pagenum >= $lastpage) {
          $next_page = "";
    } else {
        $next_pagenumber = $pagenum + 1;
        $next_page .= "<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=News&amp;file=article&amp;sid=$info[sid]&amp;pagenum=$next_pagenumber&amp;$commentextra\">"._NEXT." ($next_pagenumber/$lastpage)</a> <a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=News&amp;file=article&amp;sid=$info[sid]&amp;pagenum=$next_pagenumber&amp;$commentextra\"><img src=\"modules/$ModName/images/right.gif\" border=\"0\" alt=\""._NEXT."\"></a>";
    }
    if($pagenum <= 1) {
                $previous_page = "";
        } else {
                $previous_pagenumber = $pagenum - 1;
                $previous_page = "<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=News&amp;file=article&amp;sid=$info[sid]&amp;$commentextra&amp;pagenum=$previous_pagenumber&amp;$commentextra\"><img src=\"modules/$ModName/images/left.gif\" border=\"0\" alt=\""._PREVIOUS."\"></a> <a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=News&amp;file=article&amp;sid=$info[sid]&amp;$commentextra&amp;pagenum=$previous_pagenumber&amp;commentextra\">"._PREVIOUS." ($previous_pagenumber/$lastpage)</a>";
        }
        if ($lastpage > 1 ) {
                $formatpages = "<center><table width=\"85%\"><tr><td align=\"left\" width=\"50%\">";
                $formatpages .= $previous_page;
                $formatpages .= "</td><td align=\"right\" width=\"50%\">".$next_page."</td></tr></table></center>";
                $info['bodytext'] = $info['bodytext'].$formatpages;
        }

    $info['hometext'] = genBBcodeDisplay($info['hometext']);
    $info['bodytext'] = genBBcodeDisplay($info['bodytext']);
    $info['notes'] = genBBcodeDisplay($info['notes']);

    if ($pagenum <= 1) {
    $info['maintext'] = $info['hometext']."\n".$info['bodytext'];
    } else {
        $info['maintext'] = '$info[bodytext]';
    }
    if (!empty($info['notes'])) {
        $info['fulltext'] = $info['maintext']."\n".$info['notes'];
    } else {
        $info['fulltext'] = $info['maintext'];
    }
    $info['skins'] = $info['skins'];
    return($info);
}

function genArticleLinks($info) {

    $component = 'AddStory::';
    $instance = "$info[aid]:$info[cattitle]:$info[sid]";
    $commentextra = pnUserGetCommentOptions();

    if (pnSecAuthAction(0, $component, $instance, ACCESS_COMMENT)) {
        $comment = "modules.php?op=modload&amp;name=News&amp;file=article&amp;sid=$info[sid]&amp;$commentextra";
    } else {
        $comment = "";
    }

    if (pnSecAuthAction(0, $component, $instance, ACCESS_READ)) {
        $fullarticle = "modules.php?op=modload&amp;name=News&amp;file=article&amp;sid=$info[sid]&amp;$commentextra";
    } else {
        $fullarticle = "";
    }

    if (!empty($info['tid'])) {
        $searchtopic = "modules.php?op=modload&amp;name=News&amp;file=index&amp;catid=&amp;topic=$info[tid]";
    } else {
        $searchtopic = '';
    }

    $links = array (
                    "category" => "modules.php?op=modload&amp;name=News&amp;file=index&amp;catid=$info[catid]",
                    "comment" => $comment,
                    "fullarticle" => $fullarticle,
                    "searchtopic" => $searchtopic,
                    "print" => "print.php?sid=$info[sid]",
                    "send" => "modules.php?op=modload&amp;name=Recommend_Us&amp;file=index&amp;req=FriendSend&amp;sid=$info[sid]",
                    "version" => 1
                    );

    return $links;
}

function genBBcodeDisplay($html) {

        if (pnModAvailable('postbbcode')) {
                if (pnModAPILoad('postbbcode', 'user')){
                $html = pnModAPIFunc('postbbcode', 'user', 'bbtohtml', array("bbcode" => $html));
                }
                if (!isset($html)){
                } else {
                        $output = $html;
                }
                return $output;
        }
}

function genArticlePreformat($info, $links) {

    $component = 'AddStory::';
    $instance = "$info[aid]:$info[cattitle]:$info[sid]";

    if (pnModAvailable("Recommend_Us")) {
        $send = "<a class=\"pn-normal\" href=\"$links[send]\"><img src=\"images/global/friend.gif\" border=\"0\" alt=\""._FRIEND."\"></a>";
    } else {
        $send = "";
    }

    $hometext = $info['hometext'];
    $bodytext = $info['bodytext'];
    $bytesmore = strlen($info['bodytext']);
    $readmore = "";
    $bytesmorelink = "";
    if ($bytesmore > 0) {
        if (pnSecAuthAction(0, $component, $instance, ACCESS_READ)) {
            $readmore = "<a class=\"pn-normal\" href=\"$links[fullarticle]\">"._READMORE."</a>";
        }
        $bytesmorelink = "$bytesmore "._BYTESMORE;
    }

    if (pnSecAuthAction(0, $component, $instance, ACCESS_READ)) {
        $title = "<a class=\"pn-title\" href=\"$links[fullarticle]\">$info[title]</a>";
    } else {
        $title = $info['title'];
    }

    if (pnSecAuthAction(0, $component, $instance, ACCESS_READ)) {
        $print = "<a class=\"pn-normal\" href=\"$links[print]\"><img src=\"images/global/print.gif\" border=\"0\" alt=\""._PRINTER."\"></a>";
    } else {
        $print = '';
    }

    $comment = "";
    if ($info['withcomm'] == 0) {
        if ($info['comments'] == 0) {
            $comment = _COMMENTSQ;
        } else if ($info['comments'] == 1) {
            $comment = "1 " . _COMMENT;
        } else {
            $comment = "$info[comments] "._COMMENTS;
        }
    }

    if (pnSecAuthAction(0, $component, $instance, ACCESS_COMMENT)) {
        $comment = "<a class=\"pn-normal\" href=\"$links[comment]\">$comment</a>";
    } else if (pnSecAuthAction(0, $component, $instance, ACCESS_READ)) {
        $comment = "$comment";
    } else {
        $comment = "";
    }

    if (!empty($info['notes'])) {
        $notes = _NOTE." <i>$info[notes]</i>";
    } else {
        $notes = "";
    }

    $preformat = array(
                       "bodytext" => $bodytext,
                       "bytesmore" => $bytesmorelink,
                       "category" => "<a href=\"$links[category]\">$info[cattitle]</a>",
                       "comment" => $comment,
                       "hometext" => $hometext,
                       "notes" => $notes,
                       "searchtopic" => "<a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=News&amp;file=index&amp;catid=&amp;topic=$info[tid]\"><img src=\"".pnConfigGetVar('tipath')."$info[topicimage]\" border=\"0\" Alt=\"$info[topictext]\" align=\"left\" hspace=\"5\" vspace=\"5\"></a>",
                       "print" => $print,
                       "readmore" => $readmore,
                       "send" => $send,
                       "title" => $title,
                       "version" => 1
                       );

    $preformat['more'] = "";
    if ($bytesmore > 0) {
        $preformat['more'] .= "$preformat[readmore] ($preformat[bytesmore]) ";
    }
    $preformat['more'] .= "$preformat[comment] $preformat[send] $preformat[print]";

    if ($info['catid']) {
        $preformat['catandtitle'] = "$preformat[category]: $preformat[title]";
    } else {
        $preformat['catandtitle'] = $preformat['title'];
    }
    $preformat['maintext'] = "$preformat[hometext]<BR><BR>$preformat[bodytext]";
    if (!empty($preformat['notes'])) {
        $preformat['fulltext'] = "$preformat[maintext]<BR><BR>$preformat[notes]";
    } else {
        $preformat['fulltext'] = "$preformat[maintext]";
    }

    return $preformat;
}

function automatednews()
{
    list($dbconn) = pnDBGetConn();
    $pntable = pnDBGetTables();

    $currentlang = pnUserGetLang();

    if (pnConfigGetVar('multilingual') == 1) {
        $column = &$pntable['autonews_column'];
        $querylang = "WHERE ($column[alanguage]='$currentlang' OR $column[alanguage]='')";
    } else {
        $querylang = "";
    }
    $today = getdate();
    $day = $today['mday'];
    if ($day < 10) {
        $day = "0$day";
    }
    $month = $today['mon'];
    if ($month < 10) {
        $month = "0$month";
    }
    $year = $today['year'];
    $hour = $today['hours'];
    if ($hour < 10) {
        $hour = "0$hour";
    }
    $min = $today['minutes'];
    if ($min < 10) {
        $min = "0$min";
    }
    $sec = "00";
    $column = &$pntable['autonews_column'];
    $result = $dbconn->Execute("SELECT $column[anid], $column[time]
                              FROM $pntable[autonews]
                              $querylang");
    while(list($anid, $time) = $result->fields) {

        $result->MoveNext();
        $timenews = substr($time, 0,4).substr($time, 5,2).substr($time, 8,2).substr($time, 11,2).substr($time, 14,2).substr($time, 17,2) ;
        $timenewsn = $timenews + 1 - 1;
        $now = "$year$month$day$hour$min$sec";
        $nown = $now + 1 - 1;
        if ($timenewsn < $nown)     {
        $column = &$pntable['autonews_column'];
        $result2 = $dbconn->Execute("SELECT $column[catid], $column[aid], $column[title], $column[hometext], $column[bodytext], $column[topic], $column[informant], $column[notes], $column[ihome], $column[alanguage] FROM $pntable[autonews] WHERE $column[anid]='$anid'");

                while(list($catid, $aid, $title, $hometext, $bodytext, $topic, $author, $notes, $ihome, $alanguage) = $result2->fields) {
                    $title = stripslashes(FixQuotes($title));
                    $hometext = stripslashes(FixQuotes($hometext));
                    $bodytext = stripslashes(FixQuotes($bodytext));
                    $notes = stripslashes(FixQuotes($notes));
                    $scol = &$pntable['stories_column'];
                    $new_sid = $dbconn->GenId($pntable['stories']);
                    $insert = $dbconn->Execute("INSERT INTO $pntable[stories] ($scol[sid], $scol[cid], $scol[aid], $scol[title], $scol[time], $scol[hometext], $scol[bodytext], $scol[comments], $scol[counter], $scol[topic], $scol[informant], $scol[notes], $scol[ihome], $scol[themeoverride], $scol[alanguage] ) VALUES ($new_sid, '$catid', '$aid', '$title', now(), '$hometext', '$bodytext', '0', '0', '$topic', '$author', '$notes', '$ihome', '', '$alanguage')");
                    if ($insert === false) {
                        error_log ("Problem deleting autonews story: $anid, '$title'");
                        PN_DBMsgError($dbconn, __FILE__, __LINE__, "Problem deleting autonews story");
                    } else {
                        $dbconn->Execute("DELETE FROM $pntable[autonews] where $column[anid]='$anid'");
                                        }
                    $result2->MoveNext();
                }
        }
    }
}
function pagelinks($hposition, $pagelinks=5, $storynum=5, $num_record)
{
        switch($hposition)
        {
                case 0:
                        // Nope - no display :-)
                break;

                case 1:
                        echo("<div align=\"left\">");
                        printlinks( $pagelinks, $storynum, $num_record );
                        echo("</div>");
                break;

                case 2:
                        echo("<div align=\"center\">");
                        printlinks($pagelinks, $storynum, $num_record );
                        echo("</div>");
                break;

                case 3:
                        echo("<div align=\"right\">");
                        printlinks( $pagelinks, $storynum, $num_record );
                        echo("</div>");
                break;

                default:
                break;
        }
}


function printlinks($pagelinks=5, $storynum=5, $num_record )
{
        global $startrow;

        // Calculate the total number of pages
        $pages = intval($num_record / $storynum);

        // $pages now contains number of pages needed unless there are left over from division
        if ($num_record % $storynum)
        {
                // has left over from division, so add one page
                $pages++;
        }

        $last = ($pages * $storynum) - $storynum;

        if( $pages == 1 )
        {
                echo("<font class=\"pn-sub\">&nbsp;"._PAGETOTAL." "._PAGETEXT.": <b>$pages</b> "._GOTO." ");
        }
        else
        {
                echo("<font class=\"pn-sub\">&nbsp;"._PAGETOTAL." "._PAGETEXTS.": <b>$pages</b> "._GOTO." ");
        }

        $cur_page = ceil( $startrow / $storynum ) + 1;
        $check = intval(($cur_page-1) / $pagelinks)*$pagelinks + 1;

        // Calculate the previous results, only print 'Previous' if startrow is not equal to zero
        if ($startrow != 0 && ($startrow >= ($storynum * $pagelinks)))
        {
                //$prevrow = $startrow - ($storynum * $links);
                $prevrow = ($check-$pagelinks-1) * $storynum;
                if ($prevrow < 0)
                {
                        $prevrow = 0;
                }
                echo("<font class=\"pn-sub\">[ <a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=News&amp;file=index&amp;catid=$catid&amp;topic=$topic&startrow=0\" title=\""._PAGEBEGIN." "._PAGETEXT."\">"._PAGEBEGIN."</a> ]&nbsp</font>");
                echo("<font class=\"pn-sub\">[ <a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=News&amp;file=index&amp;catid=$catid&amp;topic=$topic&startrow=$prevrow\" title=\""._PAGEPREVTEXT." $links "._PAGETEXTS."\">"._PAGEPREV."</a> ]&nbsp</font>");
        }

        // Print the next pages, first check if there are more pages then 1
        if ($pages >= 1)
        {
                $loop = 0;

                $end_page_links = $check + $pagelinks - 1;

                if ($end_page_links > $pages)
                {
                        $loop = $pages;
                        $o = $check;
                }
                else
                {
                        $loop = $end_page_links;
                        $o = $check;
                }
                for ($i=$o; $i <= $loop; $i++)
                { // Begin loop
                        $nextrow = $storynum * ($i - 1);
                        //Check for current page - if it is: do not put a link
                        if($cur_page == $i)
                        {
                                echo(" <b>$i</b>&nbsp;</font>");
                        }
                        else
                        {
                                $title = ucfirst(_PAGETEXT)." $i ";
                                echo(" <a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=News&amp;file=index&amp;catid=$catid&amp;topic=$topic&startrow=$nextrow\" title=\"$title\">$i</a> ");
                        }

                }
        }
        //End loop
        // Check if we are at the last page, if so, dont print 'Next'
        if ( ($pages > ($check + $pagelinks - 1)) && $pages != 1 && ($num_record > 1))
        {
        // not the last page so print Next $links pages
                $nextrow = $storynum * ($check + $pagelinks - 1);
                echo(" <a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=News&amp;file=index&amp;catid=$catid&amp;topic=$topic&startrow=$nextrow\" title=\""._PAGENEXTTEXT." $links "._PAGETEXTS."\">"._PAGENEXT."</a> &nbsp;");
                echo(" <a class=\"pn-normal\" href=\"modules.php?op=modload&amp;name=News&amp;file=index&amp;catid=$catid&amp;topic=$topic&startrow=$last\" title=\""._PAGEEND." "._PAGETEXT."\">"._PAGEEND."</a>  &nbsp;");
        }
        echo("<br>");
}


?>
